from typing import List


# region OKING-HUB - Conjunto de Classes - BUILDER
class Queue:
    def __init__(self, valor, status, data_pedido, valor_frete, pedido_canal, valor_desconto
                 , pedido_oking_id, pedido_venda_id, numero_pedido_externo, valor_total_sem_desconto
                 , valor_adicional_forma_pagt, protocolo
                 ):
        self.valor = valor
        self.status = status
        self.data_pedido = data_pedido
        self.valor_frete = valor_frete
        self.pedido_canal = pedido_canal
        self.valor_desconto = valor_desconto
        self.pedido_oking_id = pedido_oking_id
        self.pedido_venda_id = pedido_venda_id
        self.numero_pedido_externo = numero_pedido_externo
        self.valor_total_sem_desconto = valor_total_sem_desconto
        self.valor_adicional_forma_pagt = valor_adicional_forma_pagt
        self.protocolo = protocolo


class Order:
    def __init__(self, capa: dict, item: dict, entrega: dict, usuario: dict, adiconal: dict, pagamento: dict,
                 data_pagamento: str, registro_status: dict, endereco_entrega: dict,
                 data_sincronizacao: str, data_sincronizacao_nf: str, data_sincronizacao_rastreio: str):
        self.data_sincronizacao = data_sincronizacao
        self.data_sincronizacao_nf = data_sincronizacao_nf
        self.data_sincronizacao_rastreio = data_sincronizacao_rastreio
        self.capa: OrderCapa = OrderCapa(**capa)
        self.item = item
        self.entrega = entrega
        self.usuario: OrderUsuario = OrderUsuario(**usuario)
        self.adiconal = adiconal
        self.pagamento = pagamento
        self.data_pagamento = data_pagamento
        self.registro_status: OrderStatus = OrderStatus(**registro_status)
        self.endereco_entrega = endereco_entrega
        # self.capa: OrderCapa = OrderCapa(**capa)
        # self.items: List[OrderItem] = [OrderItem(**i) for i in item]
        # self.entrega: OrderEntrega = OrderEntrega(**entrega)
        # self.usuario: OrderUsuario = OrderUsuario(**usuario)
        # self.additional_payment_amount: float = valor_adicional_forma_pagt

        # self.channel_id = canal_id
        # self.mediator_cnpj: str = cnpj_intermediador
        # self.payment_institution_cnpj: str = cnpj_instituicao_pagamento

        # payments: List[Payment] = [Payment(**p) for p in pagamento]
        # if len(payments) > 0:
        #    self.paid_date = payments[0].paid_date
        #    self.flag = payments[0].flag
        #    self.erp_payment_condition = payments[0].erp_payment_condition
        #    self.parcels = payments[0].parcels
        #    self.payment_type = payments[0].type
        #    self.purchase_code = payments[0].purchase_code
        #    self.erp_payment_option = payments[0].erp_payment_option
        #
        # try:
        #    partner_shipping_methods: List[PartnerShippingMethod] = [PartnerShippingMethod(**f) for f in
        #                                                             forma_envio_parceiro]
        # except Exception:
        #    partner_shipping_methods: List[PartnerShippingMethod] = [PartnerShippingMethod(**forma_envio_parceiro)]
        #
        # if len(partner_shipping_methods) > 0:
        #    self.shipping_mode = partner_shipping_methods[0].shipping_mode


class OrderCapa:
    def __init__(self, pedido_oking_id: str, pedido_venda_id: str, numero_pedido_externo: str,
                 valor: float, status: str, data_pedido: str,
                 pedido_canal: str, valor_frete: float = 0.0, valor_desconto: float = 0.0,
                 valor_total_sem_desconto: float = 0.0, valor_adicional_forma_pagt: float = 0.0):
        self.pedido_oking_id = pedido_oking_id
        self.pedido_venda_id = pedido_venda_id
        self.numero_pedido_externo = numero_pedido_externo
        self.valor = valor
        self.status = status
        self.data_pedido = data_pedido
        self.valor_frete = valor_frete
        self.pedido_canal = pedido_canal
        self.valor_desconto = valor_desconto
        self.valor_total_sem_desconto = valor_total_sem_desconto
        self.valor_adicional_forma_pagt = valor_adicional_forma_pagt


class OrderEntrega:
    def __init__(self, modo_envio: str, transportadora: str, codigo_rastreio: str, data_previsao_entrega: str):
        self.modo_envio = modo_envio
        self.transportadora = transportadora
        self.codigo_rastreio = codigo_rastreio
        self.data_previsao_entrega = data_previsao_entrega


class OrderStatus:
    def __init__(self, comprado_em: str, aprovado_em: str, enviado_em: str, entregue_em: str, faturado_em: str
                 , separado_em: str, cancelado_em: str, separacao_em: str):
        self.comprado_em = comprado_em
        self.aprovado_em = aprovado_em
        self.enviado_em = enviado_em
        self.entregue_em = entregue_em
        self.faturado_em = faturado_em
        self.separado_em = separado_em
        self.cancelado_em = cancelado_em
        self.separacao_em = separacao_em


class Payment:
    def __init__(self, opcao_pagamento: str, parcelas: int, bandeira: str, condicao_pagamento_erp: str,
                 tabela_financiamento_rsvarejo: str,
                 tipo_venda_rsvarejo: str, canal_venda_id: str, canal_venda: str, numero_cupom: str, valor_cupom: float,
                 codigo_compra: str,
                 codigo_pedido_canal: str, data_movimento: str, codigo_mercado: str, titulos, opcao_pagamento_erp: str):
        self.type: str = opcao_pagamento
        self.erp_payment_condition: str = condicao_pagamento_erp
        self.parcels: int = parcelas
        self.flag: str = bandeira
        self.paid_date: str = titulos[0]['data_pago']
        self.purchase_code: str = codigo_compra
        self.erp_payment_option: str = opcao_pagamento_erp


class OrderUsuario:
    def __init__(self, nome: str, cpf_cnpj: str, tipo_pessoa: str, razao_social: str, email: str,
                 data_nascimento_constituicao: str, rg: str, sexo: str, orgao: str, inscricao_estadual: str,
                 inscricao_municipal: str, codigo_representante: str, codigo_referencia_erp: str,
                 endereco_cobranca: dict,
                 telefone_residencial: str, telefone_celular: str = ''):
        self.nome = nome
        self.cpf_cnpj = cpf_cnpj
        self.tipo_pessoa = tipo_pessoa
        self.razao_social = razao_social
        self.email = email
        self.data_nascimento_constituicao = data_nascimento_constituicao
        self.rg = rg
        self.sexo = sexo
        self.orgao = orgao
        self.inscricao_estadual = inscricao_estadual
        self.inscricao_municipal = inscricao_municipal
        self.codigo_representante = codigo_representante
        self.codigo_referencia_erp = codigo_referencia_erp
        self.telefone_residencial = telefone_residencial
        self.telefone_celular = telefone_celular
        self.endereco_cobranca: OrderEndereco = OrderEndereco(**endereco_cobranca)


class OrderEndereco:
    def __init__(self, cep: str, pais: str, bairro: str, cidade: str, estado: str, numero: str, endereco: str,
                 codigo_ibge: str, complemento: str, tipo_logradouro: str, telefone_contato: str,
                 descricao_endereco: str, referencia_entrega: str):
        self.cep = cep
        self.pais = pais
        self.bairro = bairro
        self.cidade = cidade
        self.estado = estado
        self.numero = numero
        self.endereco = endereco
        self.codigo_ibge = codigo_ibge
        self.tipo_logradouro: str = tipo_logradouro or 'Rua'
        self.telefone_contato = telefone_contato
        self.descricao_endereco = descricao_endereco
        self.referencia_entrega = referencia_entrega
        self.complemento = complemento


class OrderItem:
    def __init__(self, codigo_sku: str, codigo_erp: str, quantidade: int,
                 filial_expedicao: str, cnpj_filial_venda: str, filial_faturamento: str,
                 ean: str, valor: int, valor_sem_desconto: float, valor_frete: float = 0.0, desconto: float = 0.0):
        self.codigo_sku = codigo_sku
        self.codigo_erp = codigo_erp
        self.quantidade = quantidade
        self.valor_frete = valor_frete
        self.filial_expedicao = filial_expedicao
        self.cnpj_filial_venda = cnpj_filial_venda
        self.filial_faturamento = filial_faturamento
        self.ean = ean
        self.valor = valor
        self.valor_sem_desconto = valor_sem_desconto
        self.desconto = desconto


# endregion

# region MPLACE -Conjunto de Classes para o Integração com o MPlace
class QueueMplace:
    def __init__(self, order_id, site_order_code, date, status_code, protocol, partner_order_code, get_datetime,
                 **kwargs):
        self.pedido_canal = site_order_code
        self.pedido_oking_id = order_id
        self.pedido_venda_id = order_id
        self.status = status_code
        self.data_pedido = date
        self.numero_pedido_externo = partner_order_code
        self.protocolo = protocol
        self.__dict__.update(kwargs)


class OrderMplace:
    def __init__(self, order_id, site_order_code, order_date, total_amount_undiscounted, discount_value,
                 total_amount, discount_list, freight_value, status_code, status_description, delivery_forecast,
                 tracking_code, affiliate_order, payment: dict, status_record: dict, items: list,
                 delivery_shedule: dict, customer: dict, delivery_address: dict, invoice: dict,
                 tracking: dict, partner_order_code, delivery_forecast_mplace, document_intermediator,
                 intermediate_registration_id, document_payment_institution, xped, note_observation, tax_engine,
                 **kwargs):
        self.order_id = order_id
        self.site_order_code = site_order_code
        self.order_date = order_date
        self.total_amount_undiscounted = total_amount_undiscounted
        self.discount_value = discount_value
        self.total_amount = total_amount
        self.discount_list = discount_list
        self.freight_value = freight_value
        self.status_code = status_code
        self.status_description = status_description
        self.delivery_forecast = delivery_forecast
        self.tracking_code = tracking_code
        self.affiliate_order = affiliate_order
        self.payment: PaymentMplace = PaymentMplace(**payment)
        self.status_record: StatusRecordMplace = StatusRecordMplace(**status_record)
        self.itempedido: list[ItemsMplace] = [ItemsMplace(**ite) for ite in items]
        self.delivery_shedule: list[DeliveryScheduleMplace] = [DeliveryScheduleMplace(**s) for s in delivery_shedule]
        self.customer: CustomerMplace = CustomerMplace(**customer)
        self.delivery_address: EnderecoMplace = EnderecoMplace(**delivery_address)
        if invoice is not None:
            self.invoice: InvoiceMplace = InvoiceMplace(**invoice)
        else:
            self.invoice: invoice
        if tracking is not None:
            self.tracking: TrackingMplace = TrackingMplace(**tracking)
        else:
            self.tracking: TrackingMplace = TrackingMplace(' ', ' ', ' ', ' ')
        self.partner_order_code = partner_order_code
        self.delivery_forecast_mplace = delivery_forecast_mplace
        self.document_intermediator = document_intermediator
        self.intermediate_registration_id = intermediate_registration_id
        self.document_payment_institution = document_payment_institution
        self.xped = xped
        self.note_observation = note_observation
        self.tax_engine = tax_engine
        self.__dict__.update(kwargs)


class PaymentMplace:
    def __init__(self, flag: str, payment_options: str, plot_amount: int, **kwargs):
        self.flag = flag
        self.payment_options = payment_options
        self.plot_amount = plot_amount
        self.__dict__.update(kwargs)


class StatusRecordMplace:
    def __init__(self, purchased_at, approved_at, billed_at, separation_at, separated_at,
                 sent_at, delivery_date, canceled_at, **kwargs):
        self.purchased_at = purchased_at
        self.approved_at = approved_at
        self.billed_at = billed_at
        self.separation_at = separation_at
        self.separated_at = separated_at
        self.sent_at = sent_at
        self.delivery_date = delivery_date
        self.canceled_at = canceled_at
        self.__dict__.update(kwargs)


class ItemsMplace:
    def __init__(self, sku_seller_id: str, sku_partner_id: str, quantity: int, quantity_gift: int,
                 variation_option_id: int, sale_price_undiscounted: float, discount: float,
                 sale_price: float, discount_list: list, freight_value: float, **kwargs):
        self.sku_seller_id = sku_seller_id
        self.sku_partner_id = sku_partner_id
        self.quantity = quantity
        self.quantity_gift = quantity_gift
        self.sale_price_undiscounted = sale_price_undiscounted
        self.discount = discount
        self.sale_price = sale_price
        if discount_list is not None:
            self.discount_list: List[DiscountListMplace] = [DiscountListMplace(**d) for d in discount_list]
        else:
            self.discount_list = discount_list
        self.freight_value = freight_value
        self.variation_option_id = variation_option_id
        self.__dict__.update(kwargs)


class DiscountListMplace:
    def __init__(self, description, value, **kwargs):
        self.description = description
        self.value = value
        self.__dict__.update(kwargs)


class DeliveryScheduleMplace:
    def __init__(self, field_name, field_description, field_value, **kwargs):
        self.field_name = field_name
        self.field_description = field_description
        self.field_value = field_value
        self.__dict__.update(kwargs)


class CustomerMplace:
    def __init__(self, name, gender, type: str, document_number, identity_number, email, state_registration,
                 born_at, billing: dict, phones: dict, **kwargs):
        self.name = name
        self.gender = gender
        self.type = type
        self.document_number = document_number
        self.identity_number = identity_number
        self.email = email
        self.state_registration = state_registration
        self.born_at = born_at
        self.billing: EnderecoMplace = EnderecoMplace(**billing)
        self.phones: PhonesMplace = PhonesMplace(**phones)
        self.__dict__.update(kwargs)


class PhonesMplace:
    def __init__(self, office, mobile, **kwargs):
        self.office = office
        self.mobile = mobile
        self.__dict__.update(kwargs)


class EnderecoMplace:
    def __init__(self, postal_code, address, number, complement, city, city_ibge_code, neighborhood, reference,
                 country_id, state, **kwargs):
        self.postal_code = postal_code
        self.address = address
        self.number = number
        self.complement = complement
        self.city = city
        self.city_ibge_code = city_ibge_code
        self.neighborhood = neighborhood
        self.reference = reference
        self.country_id = country_id
        self.state = state
        self.__dict__.update(kwargs)


class InvoiceMplace:
    def __init__(self, number, serie, accessKey, linkDanfe, linkXml, issuedAt, **kwargs):
        self.number = number
        self.serie = serie
        self.accessKey = accessKey
        self.linkDanfe = linkDanfe
        self.linkXml = linkXml
        self.issuedAt = issuedAt
        self.__dict__.update(kwargs)


class TrackingMplace:
    def __init__(self, tracking_code, tracking_link, carrier, carrier_document, **kwargs):
        self.tracking_code = tracking_code
        self.tracking_link = tracking_link
        self.carrier = carrier
        self.carrier_document = carrier_document
        self.__dict__.update(kwargs)


# endregion

# region Okvendas

class QueueOking:
    def __init__(self, pedido_id,
                 numero_pedido_externo, data_pedido, status, protocolo, data_fila, observacao, valor_total,
                 pedido_agrupado, pedido_venda_canal_id, canal_venda_id):
        self.pedido_id = pedido_id
        self.numero_pedido_externo = numero_pedido_externo
        self.data_pedido = data_pedido
        self.status = status
        self.protocolo = protocolo
        self.data_fila = data_fila
        self.observacao = observacao
        self.valor_total = valor_total
        self.pedido_agrupado = pedido_agrupado
        self.pedido_venda_canal_id = pedido_venda_canal_id
        self.canal_venda_id = canal_venda_id

# endregion
